#include "buffer.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

void obuf_init(obuf *o, int nb_buffers)
{
  o->data = malloc(512 * nb_buffers); if(!o->data){printf("oom\n");exit(1);}
  o->play_next = 0;
  o->putpos = 0;
  o->len = nb_buffers;
  o->size = 512 * o->len;
  o->count = 0;
  o->partial = 0;
}

int obuf_hasroom(obuf *o)
{
  /* at least 2 buffers must be free, not sure about this partial stuff... */
  return o->count < o->len - 1;
}

int obuf_isempty(obuf *o)
{
  return o->count == 0;
}

void obuf_put(obuf *o, unsigned char *f, int len)
{
  int slen = len;
  int l;
  while (len) {
    l = len;
    if (o->putpos + l > o->size) l = o->size - o->putpos;
    memcpy(o->data + o->putpos, f, l);
    o->putpos += l; if (o->putpos == o->size) o->putpos = 0;
    len -= l;
    f += l;
  }
  o->partial += slen;
  if (o->partial >= 512) {
    o->count++;
    o->partial -= 512;
  }
}

unsigned char *obuf_play(obuf *o)
{
  unsigned char *ret = o->data + o->play_next * 512;
  o->play_next++; if (o->play_next == o->len) o->play_next = 0;
  o->count--;
  return ret;
}

void obuf_fill(obuf *o)
{
  if (!o->partial) return;
  while (o->partial != 512) {
    o->data[o->putpos + o->partial] = 0;
    o->partial++;
  }
  o->count++;
}
