#ifndef _BUFFER_H_
#define _BUFFER_H_

typedef struct {
  unsigned char *data;
  int play_next; /* next buffer to play, buffer unit */
  int putpos;    /* next pos to put data, byte unit */
  int len;       /* number of buffers */
  int size;      /* number of bytes */
  int count;     /* number of occupied buffers */
  int partial;   /* number of bytes in next buffer already put */
} obuf;

void obuf_init(obuf *, int);
int obuf_hasroom(obuf *);
int obuf_isempty(obuf *);
void obuf_put(obuf *, unsigned char *, int);
unsigned char *obuf_play(obuf *);
void obuf_fill(obuf *);

#endif /* _BUFFER_H_ */
