#include "data.h"
#include "oss.h"
#include "alsa.h"

#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <unistd.h>

int pid;

playlist list;

volatile int skip_silence;

#define NB_BUFFERS 10

void usr2(int x)
{
  skip_silence = 1;
}

int main(int n, char **v)
{
  if (n != 2) { fprintf(stderr, "play <playlist> (- for input)\n"); return 1; }

  signal(SIGUSR2, usr2);

  init_filter();

#ifndef ALSA
  if (!init_oss("/dev/dsp", 44100, 16, 1, NB_BUFFERS-1, 12, PLAY_SOUND))
    exit(0);
#else
  init_alsa();
#endif

  pid = getpid();

  load_list(&list, v[1]);
  play(&list);

#ifdef ALSA
  end_alsa();
#endif

  printf("\ndone\n");

  return 0;
}
